Gigabeat S: Implement a genuine udelay function. Timer is gated to not run in WFI...
[kugel-rb.git] / tools / rockboxdev.sh
blobe3e9a0cbb4ce4d5ee3bb3c357d7e91fddc88c558
1 #!/bin/sh
3 # Abort execution as soon as an error is encountered
4 # That way the script do not let the user think the process completed correctly
5 # and leave the opportunity to fix the problem and restart compilation where
6 # it stopped
7 set -e
9 # this is where this script will store downloaded files and check for already
10 # downloaded files
11 dlwhere="${RBDEV_DOWNLOAD:-/tmp/rbdev-dl}"
13 # will append the target string to the prefix dir mentioned here
14 # Note that the user running this script must be able to do make install in
15 # this given prefix directory. Also make sure that this given root dir
16 # exists.
17 prefix="${RBDEV_PREFIX:-/usr/local}"
19 # This directory is used to extract all files and to build everything in. It
20 # must not exist before this script is invoked (as a security measure).
21 builddir="${RBDEV_BUILD:-/tmp/rbdev-build}"
23 # This script needs to use GNU Make. On Linux systems, GNU Make is invoked
24 # by running the "make" command, on most BSD systems, GNU Make is invoked
25 # by running the "gmake" command. Set the "make" variable accordingly.
26 if [ -f "`which gmake 2>/dev/null`" ]; then
27 make="gmake"
28 else
29 make="make"
32 if [ -z $GNU_MIRROR ] ; then
33 GNU_MIRROR=ftp://ftp.gnu.org/pub/gnu
36 # If detection fails, override the value of make manually:
37 # make="make"
39 ##############################################################################
42 # These are the tools this script requires and depends upon.
43 reqtools="gcc bzip2 make patch"
46 findtool(){
47 file="$1"
49 IFS=":"
50 for path in $PATH
52 # echo "Checks for $file in $path" >&2
53 if test -f "$path/$file"; then
54 echo "$path/$file"
55 return
57 done
60 input() {
61 read response
62 echo $response
65 #$1 file
66 #$2 URL"root
67 getfile() {
68 tool=`findtool curl`
69 if test -z "$tool"; then
70 tool=`findtool wget`
71 if test -n "$tool"; then
72 # wget download
73 echo "ROCKBOXDEV: Downloading $2/$1 using wget"
74 $tool -O $dlwhere/$1 $2/$1
76 else
77 # curl download
78 echo "ROCKBOXDEV: Downloading $2/$1 using curl"
79 $tool -Lo $dlwhere/$1 $2/$1
82 if [ $? -ne 0 ] ; then
83 echo "ROCKBOXDEV: couldn't download the file!"
84 echo "ROCKBOXDEV: check your internet connection"
85 exit
88 if test -z "$tool"; then
89 echo "ROCKBOXDEV: No downloader tool found!"
90 echo "ROCKBOXDEV: Please install curl or wget and re-run the script"
91 exit
95 for t in $reqtools; do
96 tool=`findtool $t`
97 if test -z "$tool"; then
98 echo "ROCKBOXDEV: $t is required for this script to work."
99 echo "ROCKBOXDEV: Please install $t and re-run the script."
100 exit
102 done
104 ###########################################################################
105 # Verify download directory or create it
106 if test -d "$dlwhere"; then
107 if ! test -w "$dlwhere"; then
108 echo "$dlwhere exists, but doesn't seem to be writable for you"
109 exit
111 else
112 mkdir $dlwhere
113 if test $? -ne 0; then
114 echo "$dlwhere is missing and we failed to create it!"
115 exit
117 echo "$dlwhere has been created to store downloads in"
120 echo "Download directory: $dlwhere (set RBDEV_DOWNLOAD to change dir)"
121 echo "Install prefix: $prefix/[target] (set RBDEV_PREFIX to change dir)"
122 echo "Build dir: $builddir (set RBDEV_BUILD to change dir)"
124 ###########################################################################
125 # Verify that we can write in the prefix dir, as otherwise we will hardly
126 # be able to install there!
127 if test ! -w $prefix; then
128 echo "WARNING: This script is set to install in $prefix but has no write permissions for it"
129 echo "Please fix this and re-run this script"
130 exit
134 ###########################################################################
135 # If there's already a build dir, we don't overwrite it
136 if test -d $builddir; then
137 echo "You already have a $builddir directory!"
138 echo "Please remove it and re-run the script"
139 exit
142 cleardir () {
143 # $1 is the name of the build dir
144 # delete the build dirs and the source dirs
145 rm -rf $1/build-gcc $1/build-binu $1/gcc* $1/binutils*
148 buildone () {
150 arch=$1
151 gccpatch="" # default is no gcc patch
152 gccver="4.0.3" # default gcc version
153 binutils="2.16.1" # The binutils version to use
154 gccconfigure="" #default is nothing added to configure
155 binutilsconf="" #default is nothing added to configure
157 system=`uname -s`
158 gccurl="http://www.rockbox.org/gcc"
160 case $arch in
161 [Ss])
162 target="sh-elf"
163 gccpatch="gcc-4.0.3-rockbox-1.diff"
165 [Mm])
166 target="m68k-elf"
167 gccver="3.4.6"
168 case $system in
169 CYGWIN* | Darwin | FreeBSD | Interix)
170 gccpatch="gcc-3.4.6.patch"
172 Linux)
173 machine=`uname -m`
174 case $machine in
175 x86_64)
176 gccpatch="gcc-3.4.6-amd64.patch"
178 esac
182 esac
184 [Aa])
185 target="arm-elf"
186 gccpatch="rockbox-multilibs-arm-elf-gcc-4.0.3_2.diff"
188 [Ii])
189 target="mipsel-elf"
190 gccver="4.1.2"
191 binutils="2.17"
192 gccconfigure="--disable-libssp"
193 binutilsconf="--disable-werror"
194 # necessary to make binutils build on gcc 4.3+
195 case $system in
196 Interix)
197 gccpatch="gcc-4.1.2-interix.diff"
201 esac
204 echo "An unsupported architecture option: $arch"
205 exit
207 esac
209 bindir="$prefix/$target/bin"
210 if test -n $pathadd; then
211 pathadd="$pathadd:$bindir"
212 else
213 pathadd="$bindir"
216 mkdir -p $builddir
217 cd $builddir
219 summary="summary-$1"
221 echo "============================ Summary ============================" > $summary
222 echo "target: $target" >> $summary
223 echo "gcc version: $gccver" >> $summary
224 if test -n "$gccpatch"; then
225 echo "gcc patch: $gccpatch" >> $summary
227 echo "binutils: $binutils" >> $summary
228 echo "installation target: $prefix/$target" >> $summary
229 echo "" >> $summary
230 echo "When done, append $bindir to PATH" >> $summary
231 echo "=================================================================" >> $summary
233 cat $summary
235 echo ""
236 echo "In case you encounter a slow internet connection, you can use an alternative mirror."
237 echo "A list of other GNU mirrors is available here: http://www.gnu.org/prep/ftp.html"
238 echo ""
239 echo "Usage: GNU_MIRROR=[URL] ./rockboxdev.sh"
240 echo ""
241 echo "Example:"
242 echo "$ GNU_MIRROR=http://mirrors.kernel.org/gnu ./rockboxdev.sh"
243 echo ""
245 if test -f "$dlwhere/binutils-$binutils.tar.bz2"; then
246 echo "binutils $binutils already downloaded"
247 else
248 getfile binutils-$binutils.tar.bz2 $GNU_MIRROR/binutils
251 if test -f "$dlwhere/gcc-core-$gccver.tar.bz2"; then
252 echo "gcc $gccver already downloaded"
253 else
254 getfile gcc-core-$gccver.tar.bz2 $GNU_MIRROR/gcc/gcc-$gccver
257 if test -n "$gccpatch"; then
258 if test -f "$dlwhere/$gccpatch"; then
259 echo "$gccpatch already downloaded"
260 else
261 getfile "$gccpatch" "$gccurl"
265 echo "ROCKBOXDEV: extracting binutils-$binutils in $builddir"
266 tar xjf $dlwhere/binutils-$binutils.tar.bz2
267 echo "ROCKBOXDEV: extracting gcc-$gccver in $builddir"
268 tar xjf $dlwhere/gcc-core-$gccver.tar.bz2
270 if test -n "$gccpatch"; then
271 echo "ROCKBOXDEV: applying gcc patch"
272 patch -p0 < "$dlwhere/$gccpatch"
275 echo "ROCKBOXDEV: mkdir build-binu"
276 mkdir build-binu
277 echo "ROCKBOXDEV: cd build-binu"
278 cd build-binu
279 echo "ROCKBOXDEV: binutils/configure"
280 # we undefine _FORTIFY_SOURCE to make the binutils built run fine on recent
281 # Ubuntu installations
282 CFLAGS=-U_FORTIFY_SOURCE ../binutils-$binutils/configure --target=$target --prefix=$prefix/$target $binutilsconf
283 echo "ROCKBOXDEV: binutils/make"
284 $make
285 echo "ROCKBOXDEV: binutils/make install to $prefix/$target"
286 $make install
287 cd .. # get out of build-binu
288 PATH="${PATH}:$bindir"
289 SHELL=/bin/sh # seems to be needed by the gcc build in some cases
291 echo "ROCKBOXDEV: mkdir build-gcc"
292 mkdir build-gcc
293 echo "ROCKBOXDEV: cd build-gcc"
294 cd build-gcc
295 echo "ROCKBOXDEV: gcc/configure"
296 # we undefine _FORTIFY_SOURCE to make the gcc build go through fine on
297 # recent Ubuntu installations
298 CFLAGS=-U_FORTIFY_SOURCE ../gcc-$gccver/configure --target=$target --prefix=$prefix/$target --enable-languages=c $gccconfigure
299 echo "ROCKBOXDEV: gcc/make"
300 $make
301 echo "ROCKBOXDEV: gcc/make install to $prefix/$target"
302 $make install
303 cd .. # get out of build-gcc
304 cd .. # get out of $builddir
306 # end of buildone() function
309 echo ""
310 echo "Select target arch:"
311 echo "s - sh (Archos models)"
312 echo "m - m68k (iriver h1x0/h3x0, ifp7x0 and iaudio)"
313 echo "a - arm (ipods, iriver H10, Sansa, etc)"
314 echo "i - mips (Jz4740 and ATJ-based players)"
315 echo "separate multiple targets with spaces"
316 echo "(i.e. \"s m a\" will build sh, m86k and arm)"
317 echo ""
319 selarch=`input`
321 for arch in $selarch
323 echo ""
324 case $arch in
325 [Ss])
326 buildone $arch
328 [Ii])
329 buildone $arch
331 [Mm])
332 buildone $arch
334 [Aa])
335 buildone $arch
338 echo "An unsupported architecture option: $arch"
339 exit
341 esac
343 echo "Cleaning up build folder"
344 cleardir $builddir
345 echo ""
346 echo "Done!"
347 echo ""
348 echo "Make your PATH include $pathadd"
350 done
352 # show the summaries:
353 cat $builddir/summary-*